<?php
/*-----------------------------------------------------------------------------
  pToDo - Admin Modul
  -------------------
  Verarbeitung der Admin
  ----------------------
  Lizenz:

    Copyright (C) 2005 - 2006 Andreas "Pr0g" Droesch

    pToDo ist Freeware und darf ausdrcklich weitergegeben werden, sofern
    dies kostenlos und in unvernderter Form des Scripts geschieht.

    Der Autor haftet nicht fr Schden, die durch die Nutzung dieses Scripts
    entstanden sind!
  -----------------------------------------------------------------------------
  Author:

    Andreas "Pr0g" Droesch
    http://pr0g.net,
    webmaster@pr0g.net
    All Rights reserved.

  Version:

    siehe index.php
-----------------------------------------------------------------------------*/

  // Sicherheitsschutz
  if (!defined('IN_PTODO')) {
    die;
  }

  if (!UserIsAdmin($_SESSION['ptodo_user_id'])) {
    header('location: ?');
    die;
  }

  // Integer validieren
  if (isset($_GET['id'])) {
    $_GET['id'] = (int)$_GET['id'];
  }

  // Typnamen eines Navigationseintrags ermitteln
  function GetNavitemType($type) {
    global $lang;
    switch ($type) {
      case NAVITEM_GROUP: return $lang['group'];
      case NAVITEM_LINK: return $lang['weblink'];
      case NAVITEM_HTML: return $lang['html_site'];
      case NAVITEM_TODO: return $lang['todo_list'];
      case NAVITEM_FORUM: return $lang['forum'];
      default: return '';
    }
  }
  
  // Alle Gruppen als Options zusammenfassen
  function GetGroupsAsOptions($ignore) {
    $sql = 'SELECT navitem_id, navitem_title FROM ' . TABLE_NAVITEMS . ' WHERE navitem_type=' . NAVITEM_GROUP . ' ORDER BY navitem_order';
    $query = @mysql_query($sql);
    $groups = array(array('id' => 0, 'title' => $lang['group_root']));
    while ($row = @mysql_fetch_array($query)) {
      $groups[] = array('id' => $row['navitem_id'], 'title' => HtmlEnt($row['navitem_title']));
    }
    $options = '';
    for ($i = 0; $i < count($groups); $i++) {
      if ($groups[$i]['id'] != $ignore) {
        $options .= '<option value="' . $groups[$i]['id'] . '">' . $groups[$i]['title'] . '</option>';
      }
    }
    return $options;
  }
  
  // Benutzergruppen als Auswahlbox zurckliefern
  function GetUserGroupSelect($selected = -1) {
    global $lang;
    $select = '<select name="group_id">';
    // Gruppen auslesen
    $sql = 'SELECT group_id, group_name FROM ' . TABLE_GROUPS . ' WHERE group_id!=' . GROUP_GUESTS;
    $query = @mysql_query($sql);
    while ($row = @mysql_fetch_array($query)) {
      $select .= '<option value="' . $row['group_id'] . '"' . ($row['group_id'] == $selected ? ' selected="selected"' : '') . '>' . ($row['group_id'] == GROUP_DEFAULT ? $lang['group_default'] : HtmlEnt($row['group_name'])) . '</option>';
    }
    return $select . '</select>';
  }
  
  // Navigation
  if ($_GET['sub'] == 'navi') {
    $valid_id = true;
    if (isset($_GET['id'])) {
      $sql = 'SELECT COUNT(navitem_id) AS NavitemsCount FROM ' . TABLE_NAVITEMS . ' WHERE navitem_id=' . $_GET['id'];
      $query = @mysql_query($sql);
      $row = @mysql_fetch_array($query);
      if ($row['NavitemsCount'] == 0) {
        ShowError(str_replace('%s', $_GET['id'], $lang['navi_item_error']));
        $valid_id = false;
      }
    }
    if ($valid_id) {
      if ($_GET['action'] == 'add') { // Eintrag hinzufgen
        echo '<b>' . $lang['administration'] . ' - ' . $lang['navigation'] . ' - ' . $lang['navi_add'] . '</b><br /><br />';
        if (!empty($_POST['navitem_title'])) {
          // Reihenfolge ermitteln
          $sql = 'SELECT navitem_order FROM ' . TABLE_NAVITEMS . ' WHERE navitem_parentid=' . (int)$_GET['parentid'] . ' ORDER BY navitem_order DESC LIMIT 0, 1';
          $query = @mysql_query($sql);
          if (@mysql_num_rows($query) == 0) {
            $order = 0;
          } else {
            $row = @mysql_fetch_array($query);
            $order = $row['navitem_order'] + 1;
          }
          // Item eintragen
          $sql = 'INSERT INTO ' . TABLE_NAVITEMS . ' (navitem_parentid, navitem_type, navitem_title, navitem_order) VALUES (' . (int)$_GET['parentid'] . ', ' . $_POST['navitem_type'] . ', "' . $_POST['navitem_title'] . '", ' . $order . ')';
          @mysql_query($sql);
          if ($_POST['navitem_type'] == NAVITEM_HTML || $_POST['navitem_type'] == NAVITEM_LINK) {
            $sql = 'SELECT navitem_id FROM ' . TABLE_NAVITEMS . ' ORDER BY navitem_id DESC LIMIT 0, 1';
            $query = @mysql_query($sql);
            $row = @mysql_fetch_array($query);
            $action = '&action=edit&id=' . $row['navitem_id'];
          } else {
            $action = '';
          }
          header('location: ?section=admin&sub=navi' . $action);
        } else {
          $type = (isset($_GET['type']) ? $_GET['type'] : 0);
          $option_items = array(
            array(NAVITEM_GROUP, $lang['group']),
            array(NAVITEM_LINK, $lang['weblink']),
            array(NAVITEM_HTML, $lang['html_site']),
            array(NAVITEM_TODO, $lang['todo_list']),
            array(NAVITEM_FORUM, $lang['forum'])
          );
          $options = '';
          for ($i = 0; $i < count($option_items); $i++) {
            $id = $option_items[$i][0];
            if ($_GET['parentid'] > 0 && $id == NAVITEM_GROUP) {
              continue;
            }
            $options .= '<option value="' . $id . '"';
            if ($id == $type) {
              $options .= ' selected="selected"';
            }
            $options .= '>' . $option_items[$i][1] . '</option>';
          }
?>
<form action="?section=admin&amp;sub=navi&amp;action=add&amp;parentid=<?php echo (int)$_GET['parentid']; ?>" method="post">
<?php echo $lang['navi_type']; ?>: <select name="navitem_type"><?php echo $options; ?></select><br />
<br />
<?php echo $lang['navi_title']; ?>: <input type="text" name="navitem_title" /><br />
<br />
<input type="submit" accesskey="s" value="<?php echo $lang['add_item']; ?>" />
</form>
<?php
        }
      } elseif ($_GET['action'] == 'up' || $_GET['action'] == 'down') { // Eintrag nach oben/unten schieben
        $sql = 'SELECT navitem_parentid, navitem_order FROM ' . TABLE_NAVITEMS . ' WHERE navitem_id=' . $_GET['id'];
        $query = @mysql_query($sql);
        $row = @mysql_fetch_array($query);
        $order = $row['navitem_order'];
        $parent_id = $row['navitem_parentid'];
        $newpos = ($_GET['action'] == 'up' ? -1 : 1);
        $sql = 'UPDATE ' . TABLE_NAVITEMS . ' SET navitem_order=' . $order . ' WHERE navitem_parentid=' . $parent_id . ' AND navitem_order=' . ($order + $newpos);
        @mysql_query($sql);
        $sql = 'UPDATE ' . TABLE_NAVITEMS . ' SET navitem_order=' . ($order + $newpos) . ' WHERE navitem_parentid=' . $parent_id . ' AND navitem_id=' . $_GET['id'];
        @mysql_query($sql);
        header('location: ?section=admin&sub=navi');
      } elseif ($_GET['action'] == 'edit') { // Eintrag bearbeiten
        echo '<b>' . $lang['administration'] . ' - ' . $lang['navigation'] . ' - ' . $lang['edit_item'] . '</b><br /><br />';
        // Eintragstyp auslesen
        $sql = 'SELECT navitem_type FROM ' . TABLE_NAVITEMS . ' WHERE navitem_id=' . $_GET['id'];
        $query = @mysql_query($sql);
        $row = @mysql_fetch_array($query);
        $item_type = $row['navitem_type'];
        if (!empty($_POST['navitem_title'])) {
          // Eintrag ndern
          if ($item_type == NAVITEM_LINK || $item_type == NAVITEM_HTML) {
            $set_html = ', navitem_html="' . $_POST['navitem_html'] . '"';
            if ($item_type == NAVITEM_LINK) {
              $set_html .= ', navitem_linktarget=' . $_POST['navitem_target'];
            }
          } else {
            $set_html = '';
          }
          $sql = 'UPDATE ' . TABLE_NAVITEMS . ' SET navitem_title="' . $_POST['navitem_title'] . '"' . $set_html . ' WHERE navitem_id=' . $_GET['id'];
          @mysql_query($sql);
          header('location: ?section=admin&sub=navi');
        }
        if (!isset($_POST['navitem_title'])) {
          // Eintragsdaten auslesen
          $sql = 'SELECT navitem_title, navitem_html, navitem_linktarget FROM ' . TABLE_NAVITEMS . ' WHERE navitem_id=' . $_GET['id'];
          $query = @mysql_query($sql);
          $row = @mysql_fetch_array($query);
          $item_title = $row['navitem_title'];
          if ($item_type == NAVITEM_LINK || $item_type == NAVITEM_HTML) {
            $item_html = $row['navitem_html'];
            $item_target = $row['navitem_linktarget'];
          }
        } else {
          $item_title = $_POST['navitem_title'];
          if ($item_type == NAVITEM_LINK || $item_type == NAVITEM_HTML) {
            $item_html = stripslashes($_POST['navitem_html']);
            $item_target = $_POST['navitem_target'];
          }
        }
?>
<form action="?section=admin&amp;sub=navi&amp;action=edit&amp;id=<?php echo $_GET['id']; ?>" method="post">
<?php echo $lang['navi_title']; ?>: <input type="text" name="navitem_title" value="<?php echo HtmlEnt($item_title); ?>" /><br />
<br />
<?php
        if ($item_type == NAVITEM_LINK) {
          echo $lang['weblink'] . ':<br /><input type="text" name="navitem_html" class="input_text" value="' . $item_html . '" /><br /><br />' . $lang['navi_linktarget'] . ': <select name="navitem_target"><option value="' . LINKTARGET_SELF . '"' . ($item_target == LINKTARGET_SELF ? ' selected="selected"' : '') . '>' . $lang['navi_targetself'] . '</option><option value="' . LINKTARGET_FRAME . '"' . ($item_target == LINKTARGET_FRAME ? ' selected="selected"' : '') . '>' . $lang['navi_targetframe'] . '</option><option value="' . LINKTARGET_NEW . '"' . ($item_target == LINKTARGET_NEW ? ' selected="selected"' : '') . '>' . $lang['navi_targetnew'] . '</option></select><br /><br />';
        } elseif ($item_type == NAVITEM_HTML) {
          echo $lang['html_code'] . ':<br /><textarea name="navitem_html" class="textarea_admin_html">' . HtmlEnt($item_html) . '</textarea><br /><br />';
        }
?>
<input type="submit" accesskey="s" value="<?php echo $lang['edit_item']; ?>" />
</form>
<?php
      } elseif ($_GET['action'] == 'move') { // Eintrag verschieben
        echo '<b>' . $lang['administration'] . ' - ' . $lang['navigation'] . ' - ' . $lang['navi_move'] . '</b><br /><br />';
        if (isset($_POST['send'])) {
          $sql = 'SELECT navitem_parentid, navitem_order FROM ' . TABLE_NAVITEMS . ' WHERE navitem_id=' . $_GET['id'];
          $query = @mysql_query($sql);
          $row = @mysql_fetch_array($query);
          $old_parentid = $row['navitem_parentid'];
          $old_order = $row['navitem_order'];
          $sql = 'SELECT navitem_order FROM ' . TABLE_NAVITEMS . ' WHERE navitem_parentid=' . $_POST['group_id'] . ' ORDER BY navitem_order DESC LIMIT 0, 1';
          $query = @mysql_query($sql);
          if (@mysql_num_rows($query) == 0) {
            $order = 0;
          } else {
            $row = @mysql_fetch_array($query);
            $order = $row['navitem_order'] + 1;
          }
          $sql = 'UPDATE ' . TABLE_NAVITEMS . ' SET navitem_parentid=' . $_POST['group_id'] . ', navitem_order=' . $order . ' WHERE navitem_id=' . $_GET['id'];
          @mysql_query($sql);
          $sql = 'UPDATE ' . TABLE_NAVITEMS . ' SET navitem_order=navitem_order-1 WHERE navitem_parentid=' . $old_parentid . ' AND navitem_order>' . $old_order;
          @mysql_query($sql);
          header('location: ?section=admin&sub=navi');
        } else {
          // Gruppen auslesen
          $sql = 'SELECT navitem_parentid FROM ' . TABLE_NAVITEMS . ' WHERE navitem_id=' . $_GET['id'];
          $query = @mysql_query($sql);
          $row = @mysql_fetch_array($query);
          $options = GetGroupsAsOptions($row['navitem_parentid']);
          echo $lang['select_group'];
?>
<br /><br />
<form action="?section=admin&amp;sub=navi&amp;action=move&amp;id=<?php echo $_GET['id']; ?>" method="post">
<select name="group_id"><?php echo $options; ?></select><br />
<br />
<input type="submit" accesskey="s" name="send" value="<?php echo $lang['navi_move']; ?>" />
</form>
<?php
        }
      } elseif ($_GET['action'] == 'delete') { // Eintrge lschen
        echo '<b>' . $lang['administration'] . ' - ' . $lang['navigation'] . ' - ' . $lang['delete_item'] . '</b><br /><br />';
        if (isset($_POST['delete_yes']) || isset($_POST['delete_no'])) {
          if (isset($_POST['delete_yes'])) {
            $sql = 'DELETE FROM ' . TABLE_NAVITEMS . ' WHERE navitem_id=' . $_GET['id'];
            @mysql_query($sql);
            // Reihenfolge neu sortieren
            $sql = 'UPDATE ' . TABLE_NAVITEMS . ' SET navitem_order=navitem_order-1 WHERE navitem_parentid=' . $_POST['navitem_parentid'] . ' AND navitem_order>' . $_POST['navitem_order'];
            @mysql_query($sql);
            if ($_POST['navitem_type'] == NAVITEM_TODO) {
              // Listeneintrge lschen
              $sql = 'DELETE FROM ' . TABLE_ITEMS . ' WHERE navitem_id=' . $_GET['id'];
              @mysql_query($sql);
              // History lschen
              $sql = 'DELETE FROM ' . TABLE_HISTORY . ' WHERE navitem_id=' . $_GET['id'];
              @mysql_query($sql);
            } elseif ($_POST['navitem_type'] == NAVITEM_GROUP) {
              // Untereintrge verschieben
              $sql = 'SELECT navitem_order FROM ' . TABLE_NAVITEMS . ' WHERE navitem_parentid=' . $_POST['navitem_parentid'] . ' ORDER BY navitem_order DESC LIMIT 0, 1';
              $query = @mysql_query($sql);
              $row = @mysql_fetch_array($query);
              $last_order = $row['navitem_order'];
              $sql = 'SELECT navitem_id FROM ' . TABLE_NAVITEMS . ' WHERE navitem_parentid=' . $_GET['id'] . ' ORDER BY navitem_order';
              $query = @mysql_query($sql);
              while ($row = @mysql_fetch_array($query)) {
                $sql = 'UPDATE ' . TABLE_NAVITEMS . ' SET navitem_parentid=' . $_POST['navitem_parentid'] . ', navitem_order=' . ++$last_order . ' WHERE navitem_id=' . $row['navitem_id'];
                @mysql_query($sql);
              }
            }
          }
          header('location: ?section=admin&sub=navi');
        } else {
          // Eintragsnamen auslesen
          $sql = 'SELECT navitem_title, navitem_type, navitem_parentid, navitem_order FROM ' . TABLE_NAVITEMS . ' WHERE navitem_id=' . $_GET['id'];
          $query = @mysql_query($sql);
          $row = @mysql_fetch_array($query);
          $title = $row['navitem_title'] . ' (' . GetNavitemType($row['navitem_type']) . ')';
          $todo_info = ($row['navitem_type'] == NAVITEM_TODO) ? $lang['navi_delete_todoinfo'] . '  ' : '';
          if ($row['navitem_type'] == NAVITEM_GROUP) {
            $sql_2 = 'SELECT COUNT(navitem_id) AS NavitemCount FROM ' . TABLE_NAVITEMS . ' WHERE navitem_parentid=' . $_GET['id'];
            $query_2 = @mysql_query($sql_2);
            $row_2 = @mysql_fetch_array($query_2);
            if ($row_2['NavitemCount'] > 0) {
              $move_items = $lang['navi_delete_todomove'] . ': <select name="navitem_parentid">' . GetGroupsAsOptions($_GET['id']) . '</select><br /><br />';
            } else {
              $move_items = '';
            }
          } else {
            $move_items = '';
          }
?>
<form action="?section=admin&amp;sub=navi&amp;action=delete&amp;id=<?php echo $_GET['id']; ?>" method="post">
<input type="hidden" name="navitem_type" value="<?php echo $row['navitem_type']; ?>" />
<input type="hidden" name="navitem_order" value="<?php echo $row['navitem_order']; ?>" />
<input type="hidden" name="navitem_parentid" value="<?php echo $row['navitem_parentid']; ?>" />
<?php echo str_replace(array('%s', '%s2'), array($title, $todo_info), $lang['navi_delete_info']); ?><br />
<br />
<?php echo $move_items; ?>
<input type="submit" name="delete_yes" value="<?php echo $lang['yes']; ?>" /> <input type="submit" name="delete_no" value="<?php echo $lang['no']; ?>" />
</form>
<?php
        }
      } else {
        echo '<b>' . $lang['administration'] . ' - ' . $lang['navigation'] . '</b><br />';
        // Navigationsitems auslesen
        $sql = 'SELECT navitem_order FROM ' . TABLE_NAVITEMS . ' WHERE navitem_parentid=0 ORDER BY navitem_order DESC LIMIT 0, 1';
        $query = @mysql_query($sql);
        if (@mysql_num_rows($query) == 0) {
          $max_order = 0;
        } else {
          $row = @mysql_fetch_array($query);
          $max_order = $row['navitem_order'];
        }
        $sql = 'SELECT COUNT(navitem_id) AS NavitemCount FROM ' . TABLE_NAVITEMS . ' WHERE navitem_type=' . NAVITEM_GROUP;
        $query = @mysql_query($sql);
        $row = @mysql_fetch_array($query);
        $group_exists = ($row['NavitemCount'] > 0);
        $sql = 'SELECT navitem_id, navitem_type, navitem_title, navitem_order FROM ' . TABLE_NAVITEMS . ' WHERE navitem_parentid=0 ORDER BY navitem_order';
        $query = @mysql_query($sql);
        $count = @mysql_num_rows($query);
        echo '<ul>';
        if ($count > 0) {
          while ($row = @mysql_fetch_array($query)) {
            echo '<li>';
            $updownmove = '';
            if ($row['navitem_order'] > 0) {
              $updownmove .= '<a href="?section=admin&amp;sub=navi&amp;action=up&amp;id=' . $row['navitem_id'] . '">' . $lang['up'] . '</a> | ';
            }
            if ($row['navitem_order'] < $max_order) {
              $updownmove .= '<a href="?section=admin&amp;sub=navi&amp;action=down&amp;id=' . $row['navitem_id'] . '">' . $lang['down'] . '</a> | ';
            }
            if ($group_exists && $row['navitem_type'] != NAVITEM_GROUP) {
              $updownmove .= '<a href="?section=admin&amp;sub=navi&amp;action=move&amp;id=' . $row['navitem_id'] . '">' . $lang['move'] . '</a> | ';
            }
            echo GetNavitemType($row['navitem_type']) . ': ' . HtmlEnt($row['navitem_title']) . ' [ ' . $updownmove . '<a href="?section=admin&amp;sub=navi&amp;action=edit&amp;id=' . $row['navitem_id'] . '">' . $lang['edit'] . '</a> | <a href="?section=admin&amp;sub=navi&amp;action=delete&amp;id=' . $row['navitem_id'] . '">' . $lang['delete'] . '</a> ]<br /><br />';
            // Unteritems auslesen
            if ($row['navitem_type'] == NAVITEM_GROUP) {
              echo '<ul>';
              $sql_2 = 'SELECT navitem_order FROM ' . TABLE_NAVITEMS . ' WHERE navitem_parentid=' . $row['navitem_id'] . ' ORDER BY navitem_order DESC LIMIT 0, 1';
              $query_2 = @mysql_query($sql_2);
              if (@mysql_num_rows($query_2) == 0) {
                $max_order_2 = 0;
              } else {
                $row_2 = @mysql_fetch_array($query_2);
                $max_order_2 = $row_2['navitem_order'];
              }
              $sql_2 = 'SELECT navitem_id, navitem_type, navitem_title, navitem_order FROM ' . TABLE_NAVITEMS . ' WHERE navitem_parentid=' . $row['navitem_id'] . ' ORDER BY navitem_order';
              $query_2 = @mysql_query($sql_2);
              if (@mysql_num_rows($query_2) > 0) {
                while ($row_2 = @mysql_fetch_array($query_2)) {
                  $updownmove = '';
                  if ($row_2['navitem_order'] > 0) {
                    $updownmove .= '<a href="?section=admin&amp;sub=navi&amp;action=up&amp;id=' . $row_2['navitem_id'] . '">' . $lang['up'] . '</a> | ';
                  }
                  if ($row_2['navitem_order'] < $max_order_2) {
                    $updownmove .= '<a href="?section=admin&amp;sub=navi&amp;action=down&amp;id=' . $row_2['navitem_id'] . '">' . $lang['down'] . '</a> | ';
                  }
                  if ($group_exists) {
                    $updownmove .= '<a href="?section=admin&amp;sub=navi&amp;action=move&amp;id=' . $row_2['navitem_id'] . '">' . $lang['move'] . '</a> | ';
                  }
                  echo '<li>' . GetNavitemType($row_2['navitem_type']) . ': ' . HtmlEnt($row_2['navitem_title']) . ' [ ' . $updownmove . '<a href="?section=admin&amp;sub=navi&amp;action=edit&amp;id=' . $row_2['navitem_id'] . '">' . $lang['edit'] . '</a> | <a href="?section=admin&amp;sub=navi&amp;action=delete&amp;id=' . $row_2['navitem_id'] . '">' . $lang['delete'] . '</a> ]<br /><br /></li>';
                }
              }
              echo '<li><a href="?section=admin&amp;sub=navi&amp;action=add&amp;parentid=' . $row['navitem_id'] . '">' . $lang['navi_add_sub'] . '</a><br /><br /></li>';
              echo '</ul>';
            }
            echo '</li>';
          }
        }
        echo '<li><a href="?section=admin&amp;sub=navi&amp;action=add&amp;parentid=0">' . $lang['navi_add'] . '</a></li>';
        echo '</ul>';
      }
    }
  } elseif ($_GET['sub'] == 'users') { // Benutzer
    $valid_id = true;
    if (isset($_GET['id'])) {
      $sql = 'SELECT COUNT(user_id) AS UserCount FROM ' . TABLE_USERS . ' WHERE user_id=' . $_GET['id'];
      $query = @mysql_query($sql);
      $row = @mysql_fetch_array($query);
      if ($row['UserCount'] == 0) {
        ShowError(str_replace('%s', $_GET['id'], $lang['user_id_error']));
        $valid_id = false;
      }
    } elseif (isset($_GET['group_id'])) {
      $sql = 'SELECT COUNT(group_id) AS GroupCount FROM ' . TABLE_GROUPS . ' WHERE group_id=' . (int)$_GET['group_id'];
      $query = @mysql_query($sql);
      $row = @mysql_fetch_array($query);
      if ($row['GroupCount'] == 0) {
        ShowError(str_replace('%s', (int)$_GET['group_id'], $lang['group_error']));
        $valid_id = false;
      }
    }
    if ($valid_id) {
      if ($_GET['action'] == 'add') { // Benutzer hinzufgen
        echo '<b>' . $lang['administration'] . ' - ' . $lang['users'] . ' - ' . $lang['user_add_new'] . '</b><br /><br />';
        if (!empty($_POST['user_name']) && !empty($_POST['user_password'])) {
          // Benutzername prfen
          $sql = 'SELECT COUNT(user_id) AS UserCount FROM ' . TABLE_USERS . ' WHERE user_name="' . $_POST['user_name'] . '"';
          $query = @mysql_query($sql);
          $row = @mysql_fetch_array($query);
          if ($row['UserCount'] == 0) {
            if ($_POST['user_password'] == (isset($_POST['user_repassword']) ? $_POST['user_repassword'] : '')) {
              // Benutzer eintragen
              $sql = 'INSERT INTO ' . TABLE_USERS . ' (group_id, user_name, user_password, user_email, user_isadmin) VALUES (' . $_POST['group_id'] . ', "' . $_POST['user_name'] . '", "' . md5($_POST['user_password']) . '", "' . $_POST['user_email'] . '", ' . (isset($_POST['user_isadmin']) ? 1 : 0) . ')';
              @mysql_query($sql);
              header('location: ?section=admin&sub=users');
            } else {
              ShowError($lang['user_password_error'] . '<br /><br /><a href="?section=admin&amp;sub=users&amp;action=add&amp;username=' . $_POST['user_name'] . '&amp;useremail=' . $_POST['user_email'] . '&amp;group_id=' . $_POST['group_id'] . (isset($_POST['user_isadmin']) ? '&amp;isadmin=1' : '') . '">' . $lang['back'] . '</a>');
            }
          } else {
            ShowError($lang['user_name_error'] . '<br /><br /><a href="?section=admin&amp;sub=users&amp;action=add">' . $lang['back'] . '</a>');
          }
        } else {
?>
<form action="?section=admin&amp;sub=users&amp;action=add" method="post">
<table cellpadding="2" cellspacing="0">
<tr><td><?php echo $lang['user_name']; ?>:</td><td><input type="text" name="user_name" value="<?php echo HtmlEnt(isset($_GET['username']) ? $_GET['username'] : (isset($_POST['user_name']) ? stripslashes($_POST['user_name']) : '')); ?>" /></td></tr>
<tr><td><?php echo $lang['email']; ?>:</td><td><input type="text" name="user_email" value="<?php echo HtmlEnt(isset($_GET['useremail']) ? $_GET['useremail'] : (isset($_POST['user_email']) ? stripslashes($_POST['user_email']) : '')); ?>" /></td></tr>
<tr><td><?php echo $lang['password']; ?>:</td><td><input type="password" name="user_password" /></td></tr>
<tr><td><?php echo $lang['password_repeat']; ?>:</td><td><input type="password" name="user_repassword" /></td></tr>
<tr><td><?php echo $lang['group']; ?>:</td><td><?php echo GetUserGroupSelect(isset($_GET['group_id']) ? (int)$_GET['group_id'] : (isset($_POST['group_id']) ? (int)$_POST['group_id'] : '')); ?></td></tr>
<tr><td><?php echo $lang['admin_status']; ?>:</td><td><input type="checkbox" name="user_isadmin"<?php echo (isset($_POST['user_isadmin']) || isset($_GET['isadmin']) ? ' checked="checked"' : ''); ?>/></td></tr>
<tr><td colspan="2"><br /><input type="submit" accesskey="s" value="<?php echo $lang['user_add']; ?>" /></td></tr>
</table>
</form>
<?php
        }
      } elseif ($_GET['action'] == 'edit') { // Benutzer bearbeiten
        echo '<b>' . $lang['administration'] . ' - ' . $lang['users'] . ' - ' . $lang['user_edit'] . '</b><br /><br />';
        if (!empty($_POST['user_name'])) {
          // Benutzername prfen
          $sql = 'SELECT COUNT(user_id) AS UserCount FROM ' . TABLE_USERS . ' WHERE user_name="' . $_POST['user_name'] . '" AND user_id!=' . $_GET['id'];
          $query = @mysql_query($sql);
          $row = @mysql_fetch_array($query);
          if ($row['UserCount'] == 0) {
            $pass_check = true;
            if (!empty($_POST['user_password'])) {
              $pass_check = ($_POST['user_password'] == (isset($_POST['user_repassword']) ? $_POST['user_repassword'] : ''));
            }
            if ($pass_check) {
              // Benutzer ndern
              if ($_GET['id'] == $_SESSION['ptodo_user_id']) {
                $admin_status = '';
              } else {
                $admin_status = ', user_isadmin=' . (isset($_POST['user_isadmin']) ? '1' : '0');
              }
              $sql = 'UPDATE ' . TABLE_USERS . ' SET group_id=' . $_POST['group_id'] . ', user_name="' . $_POST['user_name'] . '"' . (!empty($_POST['user_password']) ? ', user_password="' . md5($_POST['user_password']) . '"' : '') . ', user_email="' . $_POST['user_email'] . '"' . $admin_status . ' WHERE user_id=' . $_GET['id'];
              @mysql_query($sql);
              header('location: ?section=admin&sub=users');
            } else {
              ShowError($lang['user_password_error'] . '<br /><br /><a href="?section=admin&amp;sub=users&amp;action=edit&amp;id=' . $_GET['id'] . '&amp;username=' . $_POST['user_name'] . '&amp;useremail=' . $_POST['user_email'] . '&amp;group_id=' . $_POST['group_id'] . (isset($_POST['user_isadmin']) ? '&amp;isadmin=1' : '') . '">' . $lang['back'] . '</a>');
            }
          } else {
            ShowError($lang['user_name_error'] . '<br /><br /><a href="?section=admin&amp;sub=users&amp;action=edit&amp;id=' . $_GET['id'] . '">' . $lang['back'] . '</a>');
          }
        } else {
          if (!isset($_POST['user_name'])) {
            // Benutzerinfos auslesen
            $sql = 'SELECT group_id, user_name, user_email, user_isadmin FROM ' . TABLE_USERS . ' WHERE user_id=' . $_GET['id'];
            $query = @mysql_query($sql);
            $row = @mysql_fetch_array($query);
            $_POST['user_name'] = addslashes($row['user_name']);
            $_POST['user_email'] = addslashes($row['user_email']);
            $_POST['group_id'] = $row['group_id'];
            if ($row['user_isadmin'] == 1) {
              $_POST['user_isadmin'] = true;
            }
          }
?>
<form action="?section=admin&amp;sub=users&amp;action=edit&amp;id=<?php echo $_GET['id']; ?>" method="post">
<table cellpadding="2" cellspacing="0">
<tr><td><?php echo $lang['user_name']; ?>:</td><td><input type="text" name="user_name" value="<?php echo HtmlEnt(isset($_GET['username']) ? $_GET['username'] : (isset($_POST['user_name']) ? stripslashes($_POST['user_name']) : '')); ?>" /></td></tr>
<tr><td><?php echo $lang['email']; ?>:</td><td><input type="text" name="user_email" value="<?php echo HtmlEnt(isset($_GET['useremail']) ? $_GET['useremail'] : (isset($_POST['user_email']) ? stripslashes($_POST['user_email']) : '')); ?>" /></td></tr>
<tr><td><?php echo $lang['password']; ?>:</td><td><input type="password" name="user_password" /> (<?php echo $lang['password_info']; ?>)</td></tr>
<tr><td><?php echo $lang['password_repeat']; ?>:</td><td><input type="password" name="user_repassword" /></td></tr>
<tr><td><?php echo $lang['group']; ?>:</td><td><?php echo GetUserGroupSelect(isset($_GET['group_id']) ? (int)$_GET['group_id'] : (isset($_POST['group_id']) ? (int)$_POST['group_id'] : '')); ?></td></tr>
<tr><td><?php echo $lang['admin_status']; ?>:</td><td>
<?php
          if ($_GET['id'] == $_SESSION['ptodo_user_id']) {
            echo $lang['user_admin_error'];
          } else {
            echo '<input type="checkbox" name="user_isadmin"' . (isset($_POST['user_isadmin']) || isset($_GET['isadmin']) ? ' checked="checked"' : '') . '/>';
          }
?>
</td></tr>
<tr><td colspan="2"><br /><input type="submit" accesskey="s" value="<?php echo $lang['user_edit']; ?>" /></td></tr>
</table>
</form>
<?php
        }
      } elseif ($_GET['action'] == 'delete') { // Benutzer lschen
        echo '<b>' . $lang['administration'] . ' - ' . $lang['users'] . ' - ' . $lang['user_delete'] . '</b><br /><br />';
        if ($_GET['id'] == $_SESSION['ptodo_user_id']) {
          ShowError($lang['user_account_error'] . '<br /><br /><a href="?section=admin&amp;sub=users">' . $lang['back'] . '</a>');
        } else {
          if (isset($_POST['delete_yes']) || isset($_POST['delete_no'])) {
            if (isset($_POST['delete_yes'])) {
              // Benutzer lschen
              $sql = 'UPDATE ' . TABLE_USERS . ' SET group_id=' . GROUP_DEFAULT . ', user_deleted=1 WHERE user_id=' . $_GET['id'];
              @mysql_query($sql);
              // Abonnierte Verweise lschen
              $sql = 'DELETE FROM ' . TABLE_ITEMWATCH . ' WHERE user_id=' . $_GET['id'];
              @mysql_query($sql);
            }
            header('location: ?section=admin&sub=users');
          } else {
            // Benutzername auslesen
            $sql = 'SELECT user_name FROM ' . TABLE_USERS . ' WHERE user_id=' . $_GET['id'];
            $query = @mysql_query($sql);
            $row = @mysql_fetch_array($query);
?>
<form action="?section=admin&amp;sub=users&amp;action=delete&amp;id=<?php echo $_GET['id']; ?>" method="post">
<?php echo str_replace('%s', HtmlEnt($row['user_name']), $lang['user_delete_text']); ?><br />
<br />
<input type="submit" name="delete_yes" value="<?php echo $lang['yes']; ?>" /> <input type="submit" name="delete_no" value="<?php echo $lang['no']; ?>" />
</form>
<?php
          }
        }
     } elseif ($_GET['action'] == 'add_group') { // Gruppe hinzufgen
        if (!empty($_POST['group_name'])) {
          // Gruppenname prfen
          $sql = 'SELECT COUNT(group_id) AS GroupCount FROM ' . TABLE_GROUPS . ' WHERE group_name="' . $_POST['group_name'] . '"';
          $query = @mysql_query($sql);
          $row = @mysql_fetch_array($query);
          if (in_array($_POST['group_name'], array($lang['group_default'], $lang['group_guests']))) {
            $row['GroupCount']++;
          }
          if ($row['GroupCount'] == 0) {
            // Gruppe eintragen
            $sql = 'INSERT INTO ' . TABLE_GROUPS . ' (group_name) VALUES ("' . $_POST['group_name'] . '")';
            @mysql_query($sql);
            header('location: ?section=admin&sub=users');
          } else {
            ShowError($lang['group_name_error'] . '<br /><br /><a href="?section=admin&amp;sub=users&amp;action=add_group">' . $lang['back'] . '</a>');
          }
        } else {
        echo '<b>' . $lang['administration'] . ' - ' . $lang['users'] . ' - ' . $lang['user_add_group'] . '</b><br /><br />';
?>
<form action="?section=admin&amp;sub=users&amp;action=add_group" method="post">
<?php echo $lang['group_name']; ?>: <input type="text" name="group_name" /><br />
<br />
<input type="submit" value="<?php echo $lang['user_group_add']; ?>" />
</form>
<?
        }
      } elseif ($_GET['action'] == 'edit_group') { // Gruppe bearbeiten
        echo '<b>' . $lang['administration'] . ' - ' . $lang['users'] . ' - ' . $lang['user_edit_group'] . '</b><br /><br />';
        $error = false;
        if (!empty($_POST['group_name'])) {
          // Gruppenname prfen
          $sql = 'SELECT COUNT(group_id) AS GroupCount FROM ' . TABLE_GROUPS . ' WHERE group_name="' . $_POST['group_name'] . '"';
          $query = @mysql_query($sql);
          $row = @mysql_fetch_array($query);
          if (in_array($_POST['group_name'], array($lang['group_default'], $lang['group_guests']))) {
            $row['GroupCount']++;
          }
          if ($row['GroupCount'] == 0) {
            // Gruppenname ndern
            $sql = 'UPDATE ' . TABLE_GROUPS . ' SET group_name="' . $_POST['group_name'] . '" WHERE group_id=' . (int)$_GET['group_id'];
            @mysql_query($sql);
          } else {
            $error = true;
            ShowError($lang['group_name_error'] . '<br /><br /><a href="?section=admin&amp;sub=users&amp;action=edit_group&amp;group_id=' . (int)$_GET['group_id'] . '">' . $lang['back'] . '</a>');
          }
        }
        if (!$error) {
          // Gruppenname auslesen
          $sql = 'SELECT group_name FROM ' . TABLE_GROUPS . ' WHERE group_id=' . (int)$_GET['group_id'];
          $query = @mysql_query($sql);
          $row = @mysql_fetch_array($query);
          $group_name = $row['group_name'];
          if ($_GET['group_id'] == GROUP_DEFAULT || $_GET['group_id'] == GROUP_GUESTS) {
            if ($_GET['group_id'] == GROUP_DEFAULT) {
              $group_name = $lang['group_default'];
            } else {
              $group_name = $lang['group_guests'];
            }
            echo $lang['group_name'] . ': ' . $group_name . '<br />';
          } else {
?>
<form action="?section=admin&amp;sub=users&amp;action=edit_group&amp;group_id=<?php echo (int)$_GET['group_id']; ?>" method="post">
<?php echo $lang['group_name']; ?>: <input type="text" name="group_name" value="<?php echo $group_name; ?>" /> <input type="submit" value="<?php echo $lang['edit']; ?>" />
</form>
<?php
          }
          echo '<br />' . $lang['group_rights'] . ':<br /><br />';
          echo '<table id="table_box">';
          echo '<tr class="tr_header"><td class="td_header">' . $lang['name'] . '</td><td class="td_header">' . $lang['type'] . '</td><td class="td_header">' . $lang['auth_view'] . '</td><td class="td_header">' . $lang['auth_add'] . '</td><td class="td_header">' . $lang['edit'] . '</td><td class="td_header">' . $lang['auth_editall'] . '</td><td class="td_header">' . $lang['delete'] . '</td><td class="td_header">' . $lang['auth_deleteall'] . '</td><td class="td_header">' . $lang['auth_isdev'] . '</td><td class="td_header">' . $lang['history'] . '</td><td class="td_header">' . $lang['download'] . '</td><td class="td_header">' . $lang['auth_adddownload'] . '</td></tr>';
          // Navigationsitems auslesen
          $tr_col1 = true;
          $sql = 'SELECT navitem_order FROM ' . TABLE_NAVITEMS . ' WHERE navitem_parentid=0 ORDER BY navitem_order DESC LIMIT 0, 1';
          $query = @mysql_query($sql);
          if (@mysql_num_rows($query) == 0) {
            $max_order = 0;
          } else {
            $row = @mysql_fetch_array($query);
            $max_order = $row['navitem_order'];
          }
          $sql = 'SELECT COUNT(navitem_id) AS NavitemCount FROM ' . TABLE_NAVITEMS . ' WHERE navitem_type=' . NAVITEM_GROUP;
          $query = @mysql_query($sql);
          $row = @mysql_fetch_array($query);
          $group_exists = ($row['NavitemCount'] > 0);
          $sql = 'SELECT navitem_id, navitem_type, navitem_title, navitem_order FROM ' . TABLE_NAVITEMS . ' WHERE navitem_parentid=0 ORDER BY navitem_order';
          $query = @mysql_query($sql);
          $count = @mysql_num_rows($query);
          $rights_list = array(
            array('right' => AUTH_VIEW, 'types' => array(NAVITEM_GROUP, NAVITEM_LINK, NAVITEM_HTML, NAVITEM_TODO, NAVITEM_FORUM)),
            array('right' => AUTH_ADD, 'types' => array(NAVITEM_TODO, NAVITEM_FORUM)),
            array('right' => AUTH_EDIT, 'types' => array(NAVITEM_TODO, NAVITEM_FORUM)),
            array('right' => AUTH_EDIT_ALL, 'types' => array(NAVITEM_TODO, NAVITEM_FORUM)),
            array('right' => AUTH_DELETE, 'types' => array(NAVITEM_TODO)),
            array('right' => AUTH_DELETE_ALL, 'types' => array(NAVITEM_TODO)),
            array('right' => AUTH_ISDEV, 'types' => array(NAVITEM_TODO)),
            array('right' => AUTH_VIEW_HISTORY, 'types' => array(NAVITEM_TODO)),
            array('right' => AUTH_VIEW_DOWNLOAD, 'types' => array(NAVITEM_TODO)),
            array('right' => AUTH_ADD_DOWNLOAD, 'types' => array(NAVITEM_TODO))
          );
          if ($count > 0) {
            while ($row = @mysql_fetch_array($query)) {
              // Rechte auslesen
              $sql_2 = 'SELECT rights_auth FROM ' . TABLE_RIGHTS . ' WHERE group_id=' . (int)$_GET['group_id'] . ' AND navitem_id=' . $row['navitem_id'];
              $query_2 = @mysql_query($sql_2);
              if (@mysql_num_rows($query_2) == 0) {
                $rights_auth = 0;
              } else {
                $row_2 = @mysql_fetch_array($query_2);
                $rights_auth = $row_2['rights_auth'];
              }
              // Rechte zusammenstellen
              $rights = '';
              foreach ($rights_list as $entry) {
                $rights .= '<td class="td_aligncenter">';
                if (in_array($row['navitem_type'], $entry['types'])) {
                  if ($_GET['group_id'] == GROUP_GUESTS && !in_array($entry['right'], array(AUTH_VIEW, AUTH_VIEW_DOWNLOAD, AUTH_VIEW_HISTORY))) {
                    $rights .= $lang['no'];
                  } else {
                    $rights .= '<a href="?section=admin&amp;sub=users&amp;action=switch_rights&amp;group_id=' . (int)$_GET['group_id'] . '&amp;item_id=' . $row['navitem_id'] . '&amp;right=' . $entry['right'] . '">' . $lang[($rights_auth & $entry['right'] ? 'yes' : 'no')] . '</a>';
                  }
                } else {
                  $rights .= '---';
                }
                $rights .= '</td>';
              }
              echo '<tr class="tr_col' . ($tr_col1 ? '1' : '2') . ($row['navitem_type'] == NAVITEM_GROUP ? '_head' : '') .'"><td>' . HtmlEnt($row['navitem_title']) . '</td><td>' . GetNavitemType($row['navitem_type']) . '</td>' . $rights . '</tr>';
              $tr_col1 = !$tr_col1;
              // Unteritems auslesen
              if ($row['navitem_type'] == NAVITEM_GROUP) {
                $sql_2 = 'SELECT navitem_order FROM ' . TABLE_NAVITEMS . ' WHERE navitem_parentid=' . $row['navitem_id'] . ' ORDER BY navitem_order DESC LIMIT 0, 1';
                $query_2 = @mysql_query($sql_2);
                if (@mysql_num_rows($query_2) == 0) {
                  $max_order_2 = 0;
                } else {
                  $row_2 = @mysql_fetch_array($query_2);
                  $max_order_2 = $row_2['navitem_order'];
                }
                $sql_2 = 'SELECT navitem_id, navitem_type, navitem_title, navitem_order FROM ' . TABLE_NAVITEMS . ' WHERE navitem_parentid=' . $row['navitem_id'] . ' ORDER BY navitem_order';
                $query_2 = @mysql_query($sql_2);
                if (@mysql_num_rows($query_2) > 0) {
                  while ($row_2 = @mysql_fetch_array($query_2)) {
                    // Rechte auslesen
                    $sql_3 = 'SELECT rights_auth FROM ' . TABLE_RIGHTS . ' WHERE group_id=' . (int)$_GET['group_id'] . ' AND navitem_id=' . $row_2['navitem_id'];
                    $query_3 = @mysql_query($sql_3);
                    if (@mysql_num_rows($query_3) == 0) {
                      $rights_auth = 0;
                    } else {
                      $row_3 = @mysql_fetch_array($query_3);
                      $rights_auth = $row_3['rights_auth'];
                    }
                    // Rechte zusammenstellen
                    $rights = '';
                    foreach ($rights_list as $entry) {
                      $rights .= '<td class="td_aligncenter">';
                      if (in_array($row_2['navitem_type'], $entry['types'])) {
                        if ($_GET['group_id'] == GROUP_GUESTS && !in_array($entry['right'], array(AUTH_VIEW, AUTH_VIEW_DOWNLOAD, AUTH_VIEW_HISTORY))) {
                          $rights .= $lang['no'];
                        } else {
                          $rights .= '<a href="?section=admin&amp;sub=users&amp;action=switch_rights&amp;group_id=' . (int)$_GET['group_id'] . '&amp;item_id=' . $row_2['navitem_id'] . '&amp;right=' . $entry['right'] . '">' . $lang[($rights_auth & $entry['right'] ? 'yes' : 'no')] . '</a>';
                        }
                      } else {
                        $rights .= '---';
                      }
                      $rights .= '</td>';
                    }
                    echo '<tr class="tr_col' . ($tr_col1 ? '1' : '2') . '"><td>&middot; ' . HtmlEnt($row_2['navitem_title']) . '</td><td>' . GetNavitemType($row_2['navitem_type']) . '</td>' . $rights . '</tr>';
                    $tr_col1 = !$tr_col1;
                  }
                }
              }
            }
          }
          echo '</table>';
        }
      } elseif ($_GET['action'] == 'switch_rights') { // Gruppenrechte ndern
        // Rechte auslesen
        $sql = 'SELECT rights_auth FROM ' . TABLE_RIGHTS . ' WHERE group_id=' . (int)$_GET['group_id'] . ' AND navitem_id=' . $_GET['item_id'];
        $query = @mysql_query($sql);
        if (@mysql_num_rows($query) == 0) {
          $row_exists = false;
          $rights = 0;
        } else {
          $row_exists = true;
          $row = @mysql_fetch_array($query);
          $rights = $row['rights_auth'];
        }
        // Rechte anpassen
        if ($_GET['right'] == AUTH_VIEW && ($rights & AUTH_VIEW)) {
          $rights = AUTH_VIEW;
        }
        $rights ^= (int)$_GET['right'];
        if ($rights > 0 && !($rights & AUTH_VIEW)) {
          $rights |= AUTH_VIEW;
        }
        // Rechte speichern
        if ($rights == 0 && $row_exists) {
          $sql = 'DELETE FROM ' . TABLE_RIGHTS . ' WHERE group_id=' . (int)$_GET['group_id'] . ' AND navitem_id=' . $_GET['item_id'];
        } else {
          if ($row_exists) {
            $sql = 'UPDATE ' . TABLE_RIGHTS . ' SET rights_auth=' . $rights . ' WHERE group_id=' . (int)$_GET['group_id'] . ' AND navitem_id=' . $_GET['item_id'];
          } else {
            $sql = 'INSERT INTO ' . TABLE_RIGHTS . ' (group_id, navitem_id, rights_auth) VALUES (' . (int)$_GET['group_id'] . ', ' . $_GET['item_id'] . ', ' . $rights . ')';
          }
        }
        @mysql_query($sql);
        // Navitem Typ und Parent auslesen
        $sql = 'SELECT navitem_type, navitem_parentid FROM ' . TABLE_NAVITEMS . ' WHERE navitem_id=' . (int)$_GET['item_id'];
        $query = @mysql_query($sql);
        $row = @mysql_fetch_array($query);
        if ($row['navitem_type'] == NAVITEM_GROUP && !($rights & AUTH_VIEW)) {
          // Rechte aller Unteritems entziehen
          $sql_2 = 'SELECT navitem_id FROM ' . TABLE_NAVITEMS . ' WHERE navitem_parentid=' . (int)$_GET['item_id'];
          $query_2 = @mysql_query($sql_2);
          if (@mysql_num_rows($query_2) > 0) {
            $navitem_ids = array();
            while ($row_2 = @mysql_fetch_array($query_2)) {
              $navitem_ids[] = $row_2['navitem_id'];
            }
            if (count($navitem_ids) > 0) {
              $sql_where = 'navitem_id=' . implode(' OR navitem_id=', $navitem_ids);
              $sql_2 = 'DELETE FROM ' . TABLE_RIGHTS . ' WHERE group_id=' . (int)$_GET['group_id'] . ' AND (' . $sql_where . ')';
              @mysql_query($sql_2);
            }
          }
        } elseif ($row['navitem_parentid'] > 0 && ($rights & AUTH_VIEW)) {
          // Gruppe des Items mit Leserecht versorgen
          $sql_2 = 'SELECT rights_auth FROM ' . TABLE_RIGHTS . ' WHERE navitem_id=' . $row['navitem_parentid'];
          $query_2 = @mysql_query($sql_2);
          if (@mysql_num_rows($query_2) == 0) {
            $sql = 'INSERT INTO ' . TABLE_RIGHTS . ' (group_id, navitem_id, rights_auth) VALUES (' . (int)$_GET['group_id'] . ', ' . $row['navitem_parentid'] . ', ' . AUTH_VIEW . ')';
          } else {
            $row_2 = @mysql_fetch_array($query);
            $sql = 'UPDATE ' . TABLE_RIGHTS . ' SET rights_auth=' . ($row_2['rights_auth'] | AUTH_VIEW) . ' WHERE group_id=' . (int)$_GET['group_id'] . ' AND navitem_id=' . $row['navitem_parentid'];
          }
          @mysql_query($sql);
        }
        header('location: ?section=admin&sub=users&action=edit_group&group_id=' . (int)$_GET['group_id']);
      } elseif ($_GET['action'] == 'delete_group') {
        echo '<b>' . $lang['administration'] . ' - ' . $lang['users'] . ' - ' . $lang['user_edit_group'] . '</b><br /><br />';
        if ($_GET['group_id'] == GROUP_DEFAULT || $_GET['group_id'] == GROUP_GUESTS) {
          ShowError(str_replace('%s', HtmlEnt($lang['group_' . ($_GET['group_id'] == GROUP_DEFAULT ? 'default' : 'guests')]), $lang['group_delete_error']));
        } else {
          if (isset($_POST['delete_yes']) || isset($_POST['delete_no'])) {
            if (isset($_POST['delete_yes'])) {
              // Benutzer der Standardgruppe zuweisen
              $sql = 'UPDATE ' . TABLE_USERS . ' SET group_id=' . GROUP_DEFAULT . ' WHERE group_id=' . (int)$_GET['group_id'];
              @mysql_query($sql);
              // Gruppe lschen
              $sql = 'DELETE FROM ' . TABLE_GROUPS . ' WHERE group_id=' . (int)$_GET['group_id'];
              @mysql_query($sql);
              // Rechte entfernen
              $sql = 'DELETE FROM ' . TABLE_RIGHTS . ' WHERE group_id=' . (int)$_GET['group_id'];
              @mysql_query($sql);
            }
            header('location: ?section=admin&sub=users');
          } else {
            // Gruppenname auslesen
            $sql = 'SELECT group_name FROM ' . TABLE_GROUPS . ' WHERE group_id=' . (int)$_GET['group_id'];
            $query = @mysql_query($sql);
            $row = @mysql_fetch_array($query);
?>
<form action="?section=admin&amp;sub=users&amp;action=delete_group&amp;group_id=<?php echo (int)$_GET['group_id']; ?>" method="post">
<?php echo str_replace('%s', HtmlEnt($row['group_name']), $lang['group_delete_text']); ?><br />
<br />
<input type="submit" name="delete_yes" value="<?php echo $lang['yes']; ?>" /> <input type="submit" name="delete_no" value="<?php echo $lang['no']; ?>" />
</form>
<?php
          }
        }
      } else {
        echo '<b>' . $lang['administration'] . ' - ' . $lang['users'] . '</b><br /><br />';
?>
<a href="?section=admin&amp;sub=users&amp;action=add_group"><?php echo $lang['user_add_group']; ?></a><br />
<br />
<a href="?section=admin&amp;sub=users&amp;action=add"><?php echo $lang['user_add_new']; ?></a><br />
<br />
<?php
        echo $lang['users_exists'] . ':<br />';
        // Gruppen auslesen
        $sql = 'SELECT group_id, group_name FROM ' . TABLE_GROUPS;
        $query = @mysql_query($sql);
        echo '<ul>';
        while ($row = @mysql_fetch_array($query)) {
          $links = '<a href="?section=admin&amp;sub=users&amp;action=edit_group&amp;group_id=' . $row['group_id'] . '">' . $lang['edit'] . '</a>';
          // Standardnamen setzen
          if ($row['group_id'] == GROUP_DEFAULT) {
            $row['group_name'] = $lang['group_default'];
          } elseif ($row['group_id'] == GROUP_GUESTS) {
            $row['group_name'] = $lang['group_guests'];
          } else {
            $links .= ' | <a href="?section=admin&amp;sub=users&amp;action=delete_group&amp;group_id=' . $row['group_id'] . '">' . $lang['delete'] . '</a>';
          }
          echo '<li>' . HtmlEnt($row['group_name']) . ' [ ' . $links  . ' ]';
          if ($row['group_id'] == GROUP_GUESTS) {
            echo '<br /><br /><ul><li>' . $lang['group_guests_only'] . '</li></ul><br /><br />';
          } else {
             // Benutzer auslesen
            $sql_2 = 'SELECT user_id, user_name, user_isadmin FROM ' . TABLE_USERS . ' WHERE user_deleted=0 AND group_id=' . $row['group_id'] . ' ORDER BY user_name';
            $query_2 = @mysql_query($sql_2);
            if (@mysql_num_rows($query_2) > 0) {
              echo '<br /><br /><ul>';
              while ($row_2 = @mysql_fetch_array($query_2)) {
                echo '<li>' . HtmlEnt($row_2['user_name']) . ($row_2['user_isadmin'] == 1 ? ' (Admin)' : '') . ' [ <a href="?section=admin&amp;sub=users&amp;action=edit&amp;id=' . $row_2['user_id'] . '">' . $lang['edit'] . '</a> ' . ($row_2['user_id'] != $_SESSION['ptodo_user_id'] ? '| <a href="?section=admin&amp;sub=users&amp;action=delete&amp;id=' . $row_2['user_id'] . '">' . $lang['delete'] . '</a> ' : '' ) . ']</li>';
              }
              echo '</ul><br /><br />';
            }
          }
          echo '</li>';
        }
        echo '</ul>';
        // Gelschte Benutzer auslesen
        echo '<br />' . $lang['users_delete'] . ':<br />';
        $sql = 'SELECT user_id, user_name, user_isadmin FROM ' . TABLE_USERS . ' WHERE user_deleted=1 ORDER BY user_name';
        $query = @mysql_query($sql);
        echo '<ul>';
        if (@mysql_num_rows($query) == 0) {
          echo '<li>' . $lang['no_users'] . '</li>';
        } else {
          while ($row = @mysql_fetch_array($query)) {
            echo '<li>' . HtmlEnt($row['user_name']) . ($row['user_isadmin'] == 1 ? ' (' . $lang['user_admin_status'] . ')' : '') . '</li>';
          }
        }
        echo '</ul>';
      }
    }
  } elseif ($_GET['sub'] == 'config') {
    echo '<b>' . $lang['administration'] . ' - ' . $lang['configs'] . '</b><br /><br />';
    if (isset($_POST['send'])) {
      // Einstellungen prfen
      if (!is_numeric($_POST['navibox_width'])) {
        $_POST['navibox_width'] = 100;
      }
      if (!is_numeric($_POST['lastitems_count'])) {
        $_POST['lastitems_count'] = 10;
      }
      if (!is_numeric($_POST['items_per_page'])) {
        $_POST['items_per_page'] = 25;
      }
      if (!is_numeric($_POST['fileupload_maxsize'])) {
        $_POST['fileupload_maxsize'] = 102400;
      }
      $_POST['fileupload_exts'] = str_replace(' ', '', $_POST['fileupload_exts']);
      $_POST['force_comments'] = 0;
      $comment_actions = array('setdev', 'edit', 'openclose', 'done');
      foreach ($comment_actions as $com) {
        if (isset($_POST['force_' . $com])) {
          $_POST['force_comments'] |= $_POST['force_' . $com];
        }
      }
      // Einstellungen zusammenstellen
      $configs = array('site_title', 'site_subtitle', 'admin_email', 'setdone_bydev', 'adddependence_byauthor', 'force_comments', 'navibox_width', 'lastitems_count', 'items_per_page', 'fileupload_dir', 'fileupload_exts', 'fileupload_maxsize', 'guest_mode', 'type_prefix_other', 'type_prefix_feature', 'type_prefix_bugfix');
      // Einstellungen speichern
      foreach ($configs as $config) {
        $sql = 'UPDATE ' . TABLE_CONFIG . ' SET config_value="' . $_POST[$config] . '" WHERE config_name="' . $config . '"';
        @mysql_query($sql);
      }
      // Zurckleiten
      header('location: ?section=admin&sub=config');
    } else {
      // Einstellungen zusammenstellen
      $configs = array();
      // Seitentitel
      $value = '<input type="text" name="site_title" value="' . HtmlEnt($cfg['site_title']) . '" />';
      $configs[] = array('sitetitle', $value);
      // Untertitel
      $value = '<input type="text" name="site_subtitle" value="' . HtmlEnt($cfg['site_subtitle']) . '" />';
      $configs[] = array('sitesubtitle', $value);
      // Adminemail
      $value = '<input type="text" name="admin_email" value="' . HtmlEnt($cfg['admin_email']) . '" />';
      $configs[] = array('adminemail', $value);
      // Verantwortlicher Entwickler
      $value = '<select name="setdone_bydev"><option value="0"' . ($cfg['setdone_bydev'] ? '' : ' selected="selected"') . '>' . $lang['author'] . '</option><option value="1"' . ($cfg['setdone_bydev'] ? ' selected="selected"' : '') . '>' . $lang['developer'] . '</option></select>';
      $configs[] = array('setdonebydev', $value);
      // Abhngigkeiten
      $value = '<select name="adddependence_byauthor"><option value="0"' . ($cfg['adddependence_byauthor'] ? '' : ' selected="selected"') . '>' . $lang['cfg_authordevs'] . '</option><option value="1"' . ($cfg['adddependence_byauthor'] ? ' selected="selected"' : '') . '>' . $lang['cfg_itemauthor'] . '</option></select>';
      $configs[] = array('adddependencebyauthor', $value);
      // Kommentare erzwingen
      $value = '<div style="text-align:left;white-space:nowrap">';
      $value .= '<input type="checkbox" name="force_setdev" value="' . COMMENT_SETDEV . '"' . ($cfg['force_comments'] & COMMENT_SETDEV ? ' checked="checked"' : '') . ' /> ' . $lang['cfg_force_setdev'] . '<br />';
      $value .= '<input type="checkbox" name="force_edit" value="' . COMMENT_EDIT . '"' . ($cfg['force_comments'] & COMMENT_EDIT ? ' checked="checked"' : '') . ' /> ' . $lang['edit_item'] . '<br />';
      $value .= '<input type="checkbox" name="force_openclose" value="' . COMMENT_OPENCLOSE . '"' . ($cfg['force_comments'] & COMMENT_OPENCLOSE ? ' checked="checked"' : '') . ' /> ' . $lang['cfg_force_openclose'] . '<br />';
      $value .= '<input type="checkbox" name="force_done" value="' . COMMENT_DONE . '"' . ($cfg['force_comments'] & COMMENT_DONE ? ' checked="checked"' : '') . ' /> ' . $lang['cfg_force_done'];
      $value .= '</div>';
      $configs[] = array('forcecomments', $value);
      // Breite der linken Navigationsbox
      $value = '<input type="text" name="navibox_width" value="' . HtmlEnt($cfg['navibox_width']) . '" />';
      $configs[] = array('naviboxwidth', $value);
      // Anzahl der Eintrge in der bersicht
      $value = '<input type="text" name="lastitems_count" value="' . HtmlEnt($cfg['lastitems_count']) . '" />';
      $configs[] = array('lastitemscount', $value);
      // Anzahl der Eintrge pro Seite
      $value = '<input type="text" name="items_per_page" value="' . HtmlEnt($cfg['items_per_page']) . '" />';
      $configs[] = array('itemsperpage', $value);
      // Ordner fr Dateiuploads
      $value = '<input type="text" name="fileupload_dir" value="' . HtmlEnt($cfg['fileupload_dir']) . '" />';
      $configs[] = array('fileuploaddir', $value);
      // Dateitypen fr Dateiuploads
      $value = '<input type="text" name="fileupload_exts" value="' . (is_array($cfg['fileupload_exts']) ? HtmlEnt(implode(',', $cfg['fileupload_exts'])) : '') . '" />';
      $configs[] = array('fileuploadexts', $value);
      // Dateigre fr Dateiuploads
      $value = '<input type="text" name="fileupload_maxsize" value="' . HtmlEnt($cfg['fileupload_maxsize']) . '" />';
      $configs[] = array('fileuploadmaxsize', $value);
      // Gstemodus aktivieren
      $value = '<select name="guest_mode"><option value="1"' . ($cfg['guest_mode'] ? ' selected="selected"' : '') . '>' . $lang['yes'] . '</option><option value="0"' . ($cfg['guest_mode'] ? '' : ' selected="selected"') . '>' . $lang['no'] . '</option></select>';
      $configs[] = array('guestmode', $value);
      // Standardprefix Typ "Sonstiges"
      $value = '<input type="text" name="type_prefix_other" value="' . HtmlEnt($cfg['type_prefix_other']) . '" />';
      $configs[] = array('typeprefixother', $value);
      // Standardprefix Typ "Feature"
      $value = '<input type="text" name="type_prefix_feature" value="' . HtmlEnt($cfg['type_prefix_feature']) . '" />';
      $configs[] = array('typeprefixfeature', $value);
      // Standardprefix Typ "Bugfix"
      $value = '<input type="text" name="type_prefix_bugfix" value="' . HtmlEnt($cfg['type_prefix_bugfix']) . '" />';
      $configs[] = array('typeprefixbugfix', $value);
      // Einstellungen ausgeben
      echo $lang['config_info'] . '<br /><br />';
      echo '<form action="?section=admin&amp;sub=config" method="post"><table id="table_box"><tr class="tr_header"><td class="td_header"><b>' . $lang['config'] . '</b></td><td class="td_header"><b>' . $lang['value'] . '</b></td></tr>';
      $c = true;
      foreach ($configs as $config) {
        echo '<tr class="tr_col' . ($c ? '1' : '2') . '"><td><b><br />' . $lang['cfg_' . $config[0]] . ':</b><br />' . $lang['cfg_' . $config[0] . '_desc'] . '<br /><br /></td><td class="td_aligncenter">' . $config[1] . '</td></tr>';
        $c = !$c;
      }
      echo '<tr class="tr_col' . ($c ? '1' : '2') . '"><td>&nbsp;</td><td class="td_aligncenter"><br /><input type="submit" name="send" value="' . $lang['config_save'] . '" /></td></tr>';
      echo '</table></form>';
    }
  } elseif ($_GET['sub'] == 'space') {
    echo '<b>' . $lang['administration'] . ' - ' . $lang['space'] . '</b><br /><br />' . $lang['space_info'] . '<br /><br /><fieldset><legend>' . $lang['space_web'] . ':</legend>';
    // Scriptspeicher ermitteln
    $script_files = array('index.php', 'config.php', 'lang_de.php', 'screen.css', 'print.css', 'm/admin.php', 'm/constants.php', 'm/forum.php', 'm/items.php', 'm/login.php', 'm/todo.php', 'm/useradmin.php', 'm/bbcode.php', 'm/bbcode.js');
    $size = $count = 0;
    foreach ($script_files as $file) {
      $size += filesize(str_replace('m/', 'modules/', $file));
      $count++;
    }
    echo $lang['space_script'] . ' (' . $count . ' ' . $lang['files'] . '): <b>' . FormatFileSize($size) . '</b><br /><br />';
    // Dateiuploadspeicher ermitteln
    $size = $count = 0;
    if ($dh = opendir($cfg['fileupload_dir'])) {
      while (false !== ($file = readdir($dh))) {
        if ($file != '.' && $file != '..') {
          $size += filesize($cfg['fileupload_dir'] . '/' . $file);
          $count++;
        }
      }
      closedir($dh);
    }
    echo $lang['space_upload'] . ' (' . $count . ' ' . $lang['file' . ($count == 1 ? '' : 's')] . '): <b>' . FormatFileSize($size) . '</b></fieldset><br /><fieldset><legend>' . $lang['space_db'] . ':</legend>';
    // Datenbankspeicher ermitteln
    $size = $count = 0;
    $ptodo_tables = array(TABLE_CONFIG, TABLE_FILES, TABLE_GROUPS, TABLE_HISTORY, TABLE_ITEMLINK, TABLE_ITEMS, TABLE_ITEMWATCH, TABLE_NAVITEMS, TABLE_POSTS, TABLE_RIGHTS, TABLE_USERS, TABLE_VERSIONS);
    $sql = 'SHOW TABLE STATUS';
    $query = @mysql_query($sql);
    while ($row = @mysql_fetch_array($query)) {
      if (in_array($row['Name'], $ptodo_tables)) {
        $size += ($row['Index_length'] + $row['Data_length']);
        $count++;
      }
    }
    echo $lang['space_db'] . ' (' . $count . ' ' . $lang['tables'] . '): <b>' . FormatFileSize($size) . '</b></fieldset>';
  } elseif ($_GET['sub'] == 'updatecheck') {
    echo '<b>' . $lang['administration'] . ' - ' . $lang['update'] . '</b><br /><br />';
    // Version berprfen
    $errno = 0;
    $errstr = $last_version = $version_info = '';
    $host = 'www.pr0g.net';
    if ($fs = @fsockopen($host, 80, $errno, $errstr)) {
      @fputs($fs, "GET /php_scripte/ptodo/version.txt HTTP/1.1\r\n");
      @fputs($fs, "HOST: $host\r\n");
      @fputs($fs, "Connection: close\r\n\r\n");
      $header_end = false;
      while (!@feof($fs)) {
        if ($header_end) {
          $last_version .= @fread($fs, 1024);
        } else {
          if (@fgets($fs, 1024) == "\r\n") {
            $header_end = true;
          }
        }
      }
      @fclose($fs);
      if ($version == $last_version) {
        $version_info = '<span style="color:#008000">' . str_replace('%s', $version, $lang['update_version_ok1']) . '</span><br /><br />' . $lang['update_version_ok2'];
      } else {
        $version_info = '<span style="color:#F00">' . str_replace('%s', $version, $lang['update_version_old1']) . '</span><br /><br />' . str_replace('%s', $last_version, $lang['update_version_old2']) . ': <a href="http://pr0g.net/go/php_scripte/#ptodo" target="_blank">' . $lang['update_download'] . '</a>.';
      }
    } else {
      if ($errstr) {
        $version_info = '<span style="color:#F00">' . $lang['update_server_error'] . ': ' . $errstr . '</span>';
      } else {
        $version_info = '<span style="color:#F00">' . $lang['update_socket_error'] . '</span>';
      }
    }
    echo $version_info;
  } else {
   echo '<b>' . $lang['administration'] . '</b><br /><br />' . $lang['admin_text'];
  }
?>