<?php
/*-----------------------------------------------------------------------------
  pToDo - BBCode Modul
  --------------------
  Verarbeitung von BBCodes
  ------------------------
  Lizenz:

    Copyright (C) 2005 - 2006 Andreas "Pr0g" Droesch

    pToDo ist Freeware und darf ausdrcklich weitergegeben werden, sofern
    dies kostenlos und in unvernderter Form des Scripts geschieht.

    Der Autor haftet nicht fr Schden, die durch die Nutzung dieses Scripts
    entstanden sind!
  -----------------------------------------------------------------------------
  Author:

    Andreas "Pr0g" Droesch
    http://pr0g.net,
    webmaster@pr0g.net
    All Rights reserved.

  Version:

    siehe index.php
-----------------------------------------------------------------------------*/

  // Sicherheitsschutz
  if (!defined('IN_PTODO')) {
    die;
  }

  // Mgliche BBCodes
  $bbcodes = array('b', 'u', 'i', 'code', 'url', 'email');

  // BBCode Buttonleiste generieren
  function GetBBCodePanel($textarea) {
    global $bbcodes, $lang;
    static $insert_script = false;
    if (!$insert_script) {
      $panel = '<script type="text/javascript" src="modules/bbcode.js"></script>';
      $insert_script = true;
    } else {
      $panel = '';
    }
    foreach ($bbcodes as $key => $tag) {
      $panel .= '<input type="button" value="' . $tag . '" onclick="InsertBBCode(\'' . $textarea . '\', \'' . $tag . '\')" title="' . $lang['bbcode_' . $key] . '" /> ';
    }
    return $panel;
  }

  // Prft einen Text auf Fehler im BBCode und berichtigt diese
  function CheckBBCode($text) {
    global $bbcodes;
    $offset = 0;
    $open = array();
    $incode = false;
    // ffnende Klammer des nchsten Tags suchen
    while (($spos = strpos($text, '[', $offset)) !== false) {
      // Schlieende Klammer des nchsten Tags suchen
      if (($epos = strpos($text, ']', $offset)) === false) {
        break;
      } else {
        // Tag extrahieren
        $tag = substr($text, $spos + 1, $epos - $spos - 1);
        if (strlen($tag) > 0) {
          // ffnender oder schlieender Tag
          if ($tag[0] == '/') {
            $opentag = false;
            $tag = substr($tag, 1, strlen($tag) - 1);
          } else {
            $opentag = true;
          }
          $tag = strtolower($tag);
          // Tag auf Gltigkeit prfen
          $valid_tag = in_array($tag, $bbcodes);
          if (!$valid_tag) {
            if (substr($tag, 0, 4) == 'url=') {
              $tag = 'url';
              $valid_tag = true;
            }
          }
          if ($tag != 'url') {
            // Nchste ffnende Klammer suchen
            if (($npos = strpos($text, '[', $offset + 1)) !== false) {
              if ($npos < $epos) {
                $offset++;
                continue;
              }
            }
          }
          // Gltiger Tag
          if ($valid_tag) {
            if ($opentag) { // ffnender Tag
              if (!$incode) {
                if ($tag == 'code') {
                  // Vorangegangene Tags schlieen
                  $filltags = '';
                  $ropen = array_reverse($open);
                  foreach ($ropen as $otag) {
                    $filltags .= '[/' . $otag . ']';
                  }
                  $temp = $text;
                  $text = substr($temp, 0, $spos) . $filltags . substr($temp, $spos);
                  $offset = $epos + strlen($filltags);
                  $open = array();
                  $incode = true;
                  continue;
                }
                // Doppelte Tags entfernen
                if (in_array($tag, $open)) {
                  $temp = $text;
                  // Bei Email schlieen statt entfernen
                  if ($open[count($open) - 1] == $tag && $tag == 'email') {
                    $text = substr($temp, 0, $spos + 1) . '/' . substr($temp, $spos  +  1);
                  } else {
                    $text = substr($temp, 0, $spos) . substr($temp, $epos  +  1);
                    $offset = $spos;
                  }
                  continue;
                }
                // Tag in Offen-Liste schreiben
                $open[] = $tag;
              }
            } else { // Schlieender Tag
              if ($incode) {
                if ($tag == 'code') {
                  $incode = false;
                }
              } else {
                if (in_array($tag, $open)) {
                  // Vorangegangene Tags schlieen
                  $filltags = '';
                  $close = array();
                  while (count($open) > 0) {
                    if ($open[count($open) - 1] == $tag) {
                      break;
                    } else {
                      $filltags .= '[/' . $open[count($open) - 1] . ']';
                      $close[] = array_pop($open);
                    }
                  }
                  array_pop($open);
                  $opentags = '';
                  $endtext = substr($text, $epos + 1);
                  if (strlen(trim($endtext)) > 0) {
                    $close = array_reverse($close);
                    foreach ($close as $ctag) {
                      $opentags .= '[' . $ctag . ']';
                      $open[] = $ctag;
                    }
                  }
                  $temp = $text;
                  $text = substr($temp, 0, $spos) . $filltags . substr($temp, $spos, $epos - $spos + 1) . $opentags . $endtext;
                  $offset = $epos + strlen($filltags) + strlen($opentags);
                  continue;
                }
                // Schlieende Tags ohne ffnenden Tag entfernen
                $temp = $text;
                $text = substr($temp, 0, $spos) . substr($temp, $epos  +  1);
                $offset = $spos;
                continue;
              }
            }
          }
        }
      }
      $offset = ++$epos;
    }
    // brige ffnende Tags schlieen
    if ($incode) {
      $text .= '[/code]';
    } else {
      $last = count($open) - 1;
      $open = array_reverse($open);
      foreach ($open as $otag) {
        $text .= '[/' . $otag . ']';
      }
    }
    return $text;
  }

  // Parst einen Text nach BBCodes
  function ParseBBCode($text) {
    global $lang;
    // Codes austrennen
    $codes = array();
    while (($spos = strpos($text, '[code]')) !== false) {
      $epos = strpos($text, '[/code]');
      $index = uniqid('ptodo_bb');
      $codes[$index] = substr($text, $spos + 6, $epos - $spos - 6);
      $pre = substr($text, 0, $spos);
      $suf = substr($text, $epos + 7, strlen($text) - $epos - 7);
      $text = $pre . '{' . $index . '}' . $suf;
    }
    // Komplexe BBCodes und Links parsen
    $search = array(
      "#\[url\]([\w]+?://([\w\#$%&~/.\-;:=,?@\]+]+|\[(?!url=))*?)\[/url\]#is",
      "#\[url\]((www|ftp)\.([\w\#$%&~/.\-;:=,?@\]+]+|\[(?!url=))*?)\[/url\]#is",
      "#\[url=([\w]+?://[^ \"\n\r\t<]*?)\](.*?)\[/url\]#is",
      "#\[url=((www|ftp)\.[^ \"\n\r\t<]*?)\](.*?)\[/url\]#is",
      "#\[email\]([a-z0-9&\-_.]+?@[\w\-]+\.([\w\-\.]+\.)?[\w]+)\[/email\]#si",
      "#(^|[\n ])([\w]+?://[\w\#$%&~/.\-;:=,?@\[\]+]*)#is",
      "#(^|[\n ])((www|ftp)\.[\w\#$%&~/.\-;:=,?@\[\]+]*)#is",
      "#(^|[\n ])([a-z0-9&\-_.]+?)@([\w\-]+\.([\w\-\.]+\.)*[\w]+)#i"
    );
    $replace = array(
      "<a href=\"\\1\" target=\"_blank\">\\1</a>",
      "<a href=\"http://\\1\" target=\"_blank\">\\1</a>",
      "<a href=\"\\1\" target=\"_blank\">\\2</a>",
      "<a href=\"http://\\1\" target=\"_blank\">\\3</a>",
      "<a href=\"mailto:\\1\">\\1</a>",
      "\\1<a href=\"http://\\2\" target=\"_blank\">\\2</a>",
      "\\1<a href=\"http://\\2\" target=\"_blank\">\\2</a>",
      "\\1<a href=\"mailto:\\2@\\3\">\\2@\\3</a>"
    );
    for ($i = 0; $i < count($search); $i++) {
      $text = preg_replace($search, $replace, $text);
    }
    // Einfache BBCodes parsen
    $search = array('[b]', '[/b]', '[u]', '[/u]', '[i]', '[/i]');
    $replace = array('<b>', '</b>', '<span style="text-decoration:underline">', '</span>', '<span style="font-style:italic">', '</span>');
    $text = str_replace($search, $replace, $text);
    // Zeilenumbrche umwandeln
    $text = nl2br($text);
    // Codes einfgen
    foreach ($codes as $index => $value) {
      $text = str_replace('{' . $index . '}', '<br /><fieldset><legend>' . $lang['code'] . ':</legend><pre>' . $value . '</pre></fieldset>', $text);
    }
    return $text;
  }
?>